<?php 

/*

    File Name: class.admin.php
	Project: ImageVine
	Author: ScriptVine.com
	Revision: 1a

*/


class Admin
{
    // vars used in script
	public $admin_exists = 0;
	public $admin_info = '';
	public $is_error = 0;
	public $message = '';
	
	// this function runs before all others to set all vars needed
	public function __construct()
	{
	    // assign globals
		global $config, $flashMessage;
		
	    if(isset($_SESSION['admin_logged_in']) && $_SESSION['admin_logged_in'] == true)
        {
		    // build query
		    $q = mysql_query("SELECT * FROM admins WHERE username = '".$_SESSION['username']."' LIMIT 1");
							  
			// assign admin row
		    $admin = mysql_fetch_array($q);

            // set vars
			$this->admin_info = $admin;
			$this->admin_exists = 1;
		}
	}
	
	
	// this function logs an admin in
	public function login($user, $password)
	{
	    // assign globals
		global $config;
		
	    if(isset($_POST['task']) && $_POST['task'] == "doLogin")
		{
		    // query database
			$q = mysql_query("SELECT * FROM admins WHERE username = '".$user."' AND password = '".sha1($password)."' LIMIT 1");
			
			// get admins info
			$r = mysql_fetch_assoc($q);
			
			// check to see if admin exists
			if(!mysql_num_rows($q))
			{
			    $this->is_error = 1;
				$this->message = "Login Error: incorrect username or password.";
			}else
			
			// check to see if member is enabled
			if($r['active'] == '0')
			{
			    $this->is_error = 1;
				$this->message = "Your admin account has been dissabled.";
			}else
			
			// no error, login
			if($this->is_error != 1)
			{
			    // set sessions
				$_SESSION['admin_logged_in'] = true;
				$_SESSION['admin_username'] = $r['username'];
				
				// redirect
			   header("Location: " . $config['base_url'] . "/admin/", 301);
			   
			   // stop
			   exit();
			}
		}
	}
	
	
	// this function logs a user out
	public function logout()
	{
	    // assign globals
		global $config;
		
		// unset sessions
		unset($_SESSION['admin_logged_in']);
		unset($_SESSION['admin_username']);
		
		 // redirect
		 header("Location: " . $config['base_url'] . "/admin/login.php", 301);
		 
		 // stop
		 exit();
	}
	
	
	// this function checks for a valid admin login session
	public function check_admin_login()
	{
	    // assign globals
		global $config;
		
		// check if user exists
		if($this->admin_exists == 0)
		{
		    // redirect to login page
		    header("Location: " . $config['base_url'] . "/admin/login.php");
			exit();
		}
	}
	
	
	// this function removes a file from the system
	public function deleteFile($file_id)
	{
	    // assign globals
		global $config, $flashMessage;
		
		// query database to find file
		$q = mysql_query("SELECT * FROM uploads WHERE id = '".$file_id."' LIMIT 1");
		$r = mysql_fetch_array($q);
		$n = mysql_num_rows($q);
		
		// if file exists
		if($n > 0)
		{
		    // remove all images and thumbs for that id
			$image = $r['image_name'];
			$thumb = substr($image, 0, strrpos($image, "."))."_thumb".substr($image, strrpos($image, "."));
			$thumb_small = substr($image, 0, strrpos($image, "."))."_thumb_small".substr($image, strrpos($image, "."));
			@unlink($config['upload_dir'] . $r['set_id'] . "/" . $image);
			@unlink($config['upload_dir'] . $r['set_id'] . "/" . $thumb);
			@unlink($config['upload_dir'] . $r['set_id'] . "/" . $thumb_small);
			
			// check for empty dir and delete
			if(($files = @scandir($config['upload_dir'] . $r['set_id'] . "/")) && count($files) <= 2)
			{
			    rmdir($config['upload_dir'] . $r['set_id'] . "/");
			}
			
			// remove from database
			mysql_query("DELETE FROM uploads WHERE id = '".$file_id."' LIMIT 1");
			
			// set flash message
			$flashMessage->setFlash('ok', 'File successfully deleted.');
			
			// redirect
			header("Location: " . $config['base_url'] . "/admin/files.php", 301);
		}
	}
	
	
	// this function removes a member from the system
	public function deleteMember($id)
	{
	    // assign globals
		global $config, $flashMessage;
		
		// remove from database
		mysql_query("DELETE FROM members WHERE id = '".$id."' LIMIT 1");
			
		// set flash message
		$flashMessage->setFlash('ok', 'Member successfully deleted.');
			
		// redirect
		header("Location: " . $config['base_url'] . "/admin/members.php", 301);
	}
	
	
	// this function updates an admins profile
	public function updateProfile($email, $password = FALSE, $username)
	{
	    // assign globals
		global $config, $flashMessage;
		
		// set password updated var
		$password_updated = FALSE;
		
		// begin building update query
		$q = "UPDATE admins SET username = '".$username."', email = '".$email."' ";
		
		// check if password is to be updated
		if($password != FALSE) 
		{ 
		    // hash password
		    $password = sha1($password);
			
			// build update row
			$q .= ", password = '".$password."' ";
			
			// set password updated var
			$password_updated = TRUE;
		}
		
		// continue update query
		$q .= "WHERE username = '".$_SESSION['admin_username']."' LIMIT 1";
		
		// run query
		mysql_query($q) or die(mysql_error());
		
		// set flash message
		$flashMessage->setFlash('admin_ok', 'Profile successfully updated.');
		
		// redirect
		if($password_updated == TRUE){ $r = "logout.php"; }else{ $r = "profile.php"; }
		header("Location: " . $config['base_url'] . "/admin/" . $r, 301);
	}
	
	
} 



/* end of class.admin.php */