<?php

class User
{
    var $user_exists = 0;
	var $user_info = "";
	var $is_error = 0;
	var $is_success = 0;
	var $message = "";
	
	// this function loads all initial data
	function __construct()
	{
	    // assign globals
		global $config, $flashMessage;
		
	    if(isset($_SESSION['logged_in']) && $_SESSION['logged_in'] == true)
        {
		    // build query
		    $q = mysql_query("SELECT * FROM members WHERE email = '".$_SESSION['email']."' LIMIT 1");
							  
			// assign user row
		    $user = mysql_fetch_array($q);

            // set vars
			$this->user_info = $user;
			$this->user_exists = 1;
		}
	}
	
	
	// this function logs a user in
	function login($email, $password)
	{
	    // assign globals
		global $config;
		
	    if(isset($_POST['task']) && $_POST['task'] == "doLogin")
		{
		    // query database
			$q = mysql_query("SELECT * FROM members WHERE email = '".$email."' AND password = '".sha1($password)."' LIMIT 1");
			
			// get members info
			$r = mysql_fetch_assoc($q);
			
			// check to see if user exists
			if(!mysql_num_rows($q))
			{
			    $this->is_error = 1;
				$this->message = "Incorrect email or password.";
			}else
			
			// check to see if member is enabled
			if($r['active'] == '0')
			{
			    $this->is_error = 1;
				$this->message = "Your account has been dissabled. please contact support.";
			}else
			
			// no error, login
			if($this->is_error != 1)
			{
			    // set sessions
				$_SESSION['logged_in'] = true;
				$_SESSION['email'] = $r['email'];
				$_SESSION['user_id'] = $r['id'];
				
				// update last login etc
				mysql_query("UPDATE members SET last_login = '".time()."',
				                                last_ip = '".$_SERVER['REMOTE_ADDR']."'
												WHERE id = '".$r['id']."'");
												
			   // redirect
			   header("Location: " . $config['base_url'] . urldecode($return), 301);
			   
			   // stop
			   exit();
			}
		}
	}
	
	
	// this function logs a user out
	function logout()
	{
	    // assign globals
		global $config;
		
		// unset sessions
		unset($_SESSION['logged_in']);
		unset($_SESSION['email']);
		unset($_SESSION['user_id']);
		
		 // redirect
		 header("Location: " . $config['base_url'], 301);
		 
		 // stop
		 exit();
	}
	
	
	// this function registers a user
	function register($email, $pass, $conf_pass)
	{
	    // assign globals
		global $config, $validation, $core;
		
		// if form is posted
	    if(isset($_POST['task']) && $_POST['task'] == "doRegister")
		{
		    // setup form validation
			$validation->addValidation("email","req","Please enter your email address.");
			$validation->addValidation("email","email","Please enter a valid email address.");
			$validation->addValidation("email","email_in_use","That email address is already in use.");
			$validation->addValidation("password","req","Please enter a valid password.");
			$validation->addValidation("password_conf","req","Please confirm your password.");
			$validation->addValidation("password","minlen=5","Your password must be 5 characters or more.");
			$validation->addValidation("password","eqelmnt=password_conf","Password fields do not match.");
            
			// run validation
			if(!$validation->ValidateForm())
			{
			    $this->is_error = 1;
				$this->message = "<strong>The following errors have occurred:</strong><br />";
				foreach($validation->GetErrors() as $inpname => $inp_err)
				{
				    $this->message .= "$inp_err<br />";
				} 
			}else
			
			// no errors, insert user
			if($this->is_error != 1)
			{
				// build insert query
				$insert_query = "INSERT INTO members (email,
				                                      password,
													  active,
													  registered,
													  ip
													  ) VALUES (
													  '".$email."',
													  '".sha1($pass)."',
													  '1',
													  '".time()."',
													  '".$_SERVER['REMOTE_ADDR']."')";
				
				// insert member in to database
				mysql_query($insert_query) or die(mysql_error());
				
				// send welcome email
				send_generic($email, 
				             $config['admin_email'], 
							 "Welcome To ".$config['site_name'], 
							 $core->loadEmailTemplate('welcome.txt'), 
							 $search = "", 
							 $replace = "");
				
				// redirect
				header("Location: " . $config['base_url'] . "/register/success", 301);
				
				// stop
				exit();
			}
		}
	}
	
	
	// this function activates a users account
	function activate($email, $code)
	{
	    // assign globals
		global $config, $flashMessage, $core;
		
		// query database
		$query = mysql_query("SELECT user_code, email, verified FROM members WHERE user_code = '".$code."' 
		                      AND email = '".$email."' LIMIT 1");
        
		// get activation info
		$act = mysql_fetch_array($query);
		
		// if activation code does not exist
		if(!mysql_num_rows($query))
		{
		    $this->is_error = 1;
			$this->message = "Sorry but that activation code does not exist in our database.";
		}else
        
		// check to see if already active
		if($act['verified'] == '1')
		{
		    $this->is_error = 1;
			$this->message = "That account is already active.";
		}
		else
		{
		    // activate account
			$query = "UPDATE members SET verified = '1' WHERE user_code = '".$code."' AND email = '".$act['email']."'";
			if(mysql_query($query))
			{
			    // build and send activated email
				send_generic($email, 
				             $config['admin_email'], 
							 "Account Activated", 
							 $core->loadEmailTemplate('activated.txt'), 
							 $search = array("[base_url]"), 
							 $replace = array($config['base_url']));
			}
		}
	}
	
	
	// this function checks for a valid login session
	function check_login()
	{
	    // assign globals
		global $config;
		
		// check if user exists
		if($this->user_exists == 0)
		{
		    // redirect to login page
		    header("Location: " . $config['base_url'] . "/login");
			exit();
		}
	}
	
	
	// this function recovers a users lost password
	function recover($email)
	{
	    // assign globals
		global $config, $core;
		
	    if(isset($_POST['task']) && $_POST['task'] == "doRecover")
		{
		    // query database
			$q = mysql_query("SELECT * FROM members WHERE email = '".$email."' LIMIT 1");
			
			// get members info
			$r = mysql_fetch_assoc($q);
			
			// check to see if user exists
			if(!mysql_num_rows($q))
			{
			    $this->is_error = 1;
				$this->message = "Sorry but we cannot find your account.";
			}else
			
			// no error, recover
			if($this->is_error != 1)
			{
			    // make temp password
				$temp_pass = randString(8);
				
				// update users password
				mysql_query("UPDATE members SET password = '".sha1($temp_pass)."' WHERE id = '".$r['id']."' LIMIT 1");
				
				// send new password email
				send_generic($email, 
				             $config['admin_email'], 
							 "New Password", 
							 $core->loadEmailTemplate('forgot_password.txt'), 
							 $search = array("[base_url]", "[temp_pass]"), 
							 $replace = array($config['base_url'], $temp_pass));
							 
				// show success message
				$this->is_success = 1;
				$this->message = "A new temporary password has been emailed to you.";
			}
		}
	}
	
	
	// this function lists files in a users account
	function listFiles($page)
	{
	    // assign globals
		global $config, $smarty, $pagination;
		
		// start query for all uploaded files
		$q = "SELECT id, image_name, original_name, views FROM uploads 
		      WHERE owner = '".$this->user_info['id']."' ORDER BY id DESC ";
		$num = mysql_num_rows(mysql_query($q));
		
		// setup pagination
		$pagination = new Pagination();
		$pagination->setLink($config['base_url'] . '/myfiles?p=%s');
		$pagination->setPage($page_number);
		$pagination->setSize(16);
		$pagination->setTotalRecords($num);
		
		// continue query for all uploaded files
		$q .= $pagination->getLimitSql();
		$r = mysql_query($q) or die(mysql_error());
		
		// loop over results and build array
		while($i = mysql_fetch_array($r))
		{
		    $filesArray[] = array("image_name" => $i['image_name'], 
			                      "original_name" => $i['original_name'], 
								  "views" => $i['views'],
								  "file_id" => $i['id']);
			}
			
			// set template vars
			$smarty->assign("files", $filesArray);
			$smarty->assign("pagination", $pagination->create_links());
    }
	
	
	// this function deletes a file
	function deleteFile($file_id)
	{
	    // assign globals
		global $config, $flashMessage;
		
		// query database to find file
		$q = mysql_query("SELECT * FROM uploads WHERE id = '".$file_id."' AND owner = '".$this->user_info['id']."' LIMIT 1");
		$r = mysql_fetch_array($q);
		$n = mysql_num_rows($q);
		
		// if file exists
		if($n > 0)
		{
		    // remove all images and thumbs for that id
			$image = $r['image_name'];
			$thumb = substr($image, 0, strrpos($image, "."))."_thumb".substr($image, strrpos($image, "."));
			$thumb_small = substr($image, 0, strrpos($image, "."))."_thumb_small".substr($image, strrpos($image, "."));
			@unlink($config['upload_dir'] . $r['set_id'] . "/" . $image);
			@unlink($config['upload_dir'] . $r['set_id'] . "/" . $thumb);
			@unlink($config['upload_dir'] . $r['set_id'] . "/" . $thumb_small);
			
			// check for empty dir and delete
			if(($files = @scandir($config['upload_dir'] . $r['set_id'] . "/")) && count($files) <= 2)
			{
			    rmdir($config['upload_dir'] . $r['set_id'] . "/");
			}
			
			// remove from database
			mysql_query("DELETE FROM uploads WHERE id = '".$file_id."' AND owner = '".$this->user_info['id']."' LIMIT 1");
			
			// set flash message
			$flashMessage->setFlash('ok', 'File successfully deleted.');
			
			// redirect
			header("Location: " . $config['base_url'] . "/myfiles", 301);
			
		}else{
		    
			// set flash message
			$flashMessage->setFlash('notok', 'Unable to delete file, it either does not exist or does not belong to you.');
			
		    // redirect
			header("Location: " . $config['base_url'] . "/myfiles", 301);
		
		}
	}
	
	
	// this function edits a users account
	function editAccount()
	{
	    // assign globals
		global $config, $validation;
		
	    if(isset($_POST['task']) && $_POST['task'] == "doEdit")
		{
		    // setup form validation
			$validation->addValidation("email","req","Please enter your email address.");
			$validation->addValidation("email","email","Please enter a valid email address.");
			            
			// run validation
			if(!$validation->ValidateForm())
			{
			    $this->is_error = 1;
				$this->message = "<strong>The following errors have occurred:</strong><br />";
				foreach($validation->GetErrors() as $inpname => $inp_err)
				{
				    $this->message .= "$inp_err<br />";
				} 
			}else
			
			// no errors, continue
			if($this->is_error != 1)
			{
		        // get for values
			    $email = isset($_POST['email']) ? $_POST['email'] : '';
			    $password = isset($_POST['password']) ? $_POST['password'] : '';
			    $password_conf = isset($_POST['password_conf']) ? $_POST['password_conf'] : '';
				
				// build update query
				$q = "UPDATE members SET email = '".$email."'";
				if($password != ''){ $q .= ",password = '".sha1($_POST['password'])."'"; }
				$q .= " WHERE email = '".$this->user_info['email']."' LIMIT 1";
				
				// run update query
				mysql_query($q);
				
				// log user out
				$this->logout();
			}  
		}
	}

	
}

/* END OF USER CLASS */