<?php

/*

    File Name: common.php
	Project: ImageVine
	Author: ScriptVine.com
	Revision: 1a

*/


// set sessions rolling
@session_start();

// include required config files
include(dirname(__FILE__) . "/configs/config.database.php");
include(dirname(__FILE__) . "/configs/config.base.php");
include(dirname(__FILE__) . "/configs/config.smarty.php");

// include required function files
include(dirname(__FILE__) . "/functions/functions.base.php");
include(dirname(__FILE__) . "/functions/functions.email.php");

// include required class files
include(dirname(__FILE__) . "/classes/class.core.php");
include(dirname(__FILE__) . "/classes/class.user.php");
include(dirname(__FILE__) . "/classes/class.flashMessages.php");
include(dirname(__FILE__) . "/classes/class.pagination.php");
include(dirname(__FILE__) . "/classes/class.admin.php");
include(dirname(__FILE__) . "/classes/class.formValidation.php");


// initialise all classes
$flashMessage = new FlashMessage;
$admin = new Admin;
$core = new Core;
$user = new User;
$validation = new FormValidator;

?>