<?php 

/*

    File Name: class.core.php
	Project: ImageVine
	Author: ScriptVine.com
	Revision: 1a

*/


class Core
{
    // vars used in script
	var $script_vrsion = '';
	var $site_config = '';
	var $is_error = 0;
	var $message = '';
	
	// this function runs before all others to set all vars needed
	function __construct()
	{
	    // assign globals
		global $config;
		
	    // include hard code script file
		include($config['base_path'] . "/version.php");
		
		// get script version
		$this->script_version = $version;
	}
	
	
	// this function loads an email template
	function loadEmailTemplate($template)
	{
	    // assign globals
		global $config;
		
		// load file contents
		$fc = @file_get_contents($config['template_dir'] . "emails/" . $template);
		
		// return output
		return $fc;
	}
	
	
	// this function sets the form value upon post or get actions
	function setFormValue($field)
	{
	    // find $field in get or post
	    if(isset($_POST[$field])){ $fv = $_POST[$field]; }else
		if(isset($_GET[$field])){ $fv = $_GET[$field]; }
		
		// return form value
		return $fv;
	}
	
	
	// this function deletes a file
	function deleteFile($del_id)
	{
	    // assign globals
		global $config, $flashMessage;
		
		// query database to find file
		$q = mysql_query("SELECT * FROM uploads WHERE delete_code = '".$del_id."' LIMIT 1");
		$r = mysql_fetch_array($q);
		$n = mysql_num_rows($q);
		
		// if file exists
		if($n > 0)
		{
		    // remove all images and thumbs for that id
			$image = $r['image_name'];
			$thumb = substr($image, 0, strrpos($image, "."))."_thumb".substr($image, strrpos($image, "."));
			$thumb_small = substr($image, 0, strrpos($image, "."))."_thumb_small".substr($image, strrpos($image, "."));
			@unlink($config['upload_dir'] . $r['set_id'] . "/" . $image);
			@unlink($config['upload_dir'] . $r['set_id'] . "/" . $thumb);
			@unlink($config['upload_dir'] . $r['set_id'] . "/" . $thumb_small);
			
			// check for empty dir and delete
			if(($files = @scandir($config['upload_dir'] . $r['set_id'] . "/")) && count($files) <= 2)
			{
			    @rmdir($config['upload_dir'] . $r['set_id'] . "/");
			}
			
			// remove from database
			mysql_query("DELETE FROM uploads WHERE id = '".$r['id']."' LIMIT 1");
			
			// set flash message
			$flashMessage->setFlash('ok', 'File successfully deleted.');
			
			// redirect
			header("Location: " . $config['base_url'], 301);
			
		}else{
		    
			// error
			$this->is_error = 1;
			$this->message = "Unable to delete file, it either does not exist or you have the wrong delete code.";
		
		}
	}
	

} 


/* end of class.core.php */