<?php 

/*

    File Name: class.flashMessage.php
	Project: ImageVine
	Author: ScriptVine.com
	Revision: 1a

*/


class FlashMessage
{
    // this function sets a flash message
    function setFlash($name, $value)
	{
	    $msg = serialize($value);
		$_SESSION['flash_message'][$name] = $msg;
	}
	
	// this function retrives a flash message
	function getFlash($name)
	{
	    $msg = unserialize($_SESSION['flash_message'][$name]);
		
		if($msg == "")
		{
		    return null;
		}
		
		unset($_SESSION['flash_message'][$name]); // remove the session after being retrieve  
		
		return $msg;  
  }
  
  // this function checks if flash message exists
  function hasFlash($name)
  {
      if(!isset($_SESSION['flash_message'][$name])){ return false; }else{ return true; }
  }
  
} 



/* end of flashMessage.php */