<?php

/*

    File Name: config.base.php
	Project: ImageVine
	Author: ScriptVine.com
	Revision: 1a

*/

$config = array();
$config['site_name'] = "ImageVine"; // the name of your site
$config['base_url'] = "http://www.yoursite.com"; // your sites main url (no trailing slash)
$config['base_path'] = "/home/yoursite/public_html"; // the server path to your site (no trailing slash)
$config['template_dir'] = $config['base_path'] . "/templates/"; // the server path to your templates (no need to edit)
$config['upload_dir'] = $config['base_path'] . "/filestore/"; // the server path to your upload folder (no need to edit)
$config['template'] = "default"; // the name of your main template (eg. default)
$config['upload_max_size'] = 3145728; // max upload file size in bytes
$config['upload_accepted_ext'] = array('png', 'jpg', 'jpeg', 'gif', 'bmp'); // array of accepted image extensions
$config['upload_accepted_mime'] = array('image/png', 'image/x-png', 'image/pjpeg', 'image/jpg', 'image/jpeg', 'image/gif', 'image/bmp'); // array of accepted image mime types
$config['adsense_pub_id'] = ""; // Your adsense publisher id
$config['admin_email'] = "admin@yoursite.com"; // your sites admin email address

?>